#include <RH_ASK.h>

#define SPEED         (uint16_t)2000
#define RX_PIN        (uint8_t)11
#define TX_PIN        (uint8_t)12
#define PTT_PIN       (uint8_t)10
#define PTT_INVERTED  false
#define DAT_ST        A0
#define LED_ST        2
#define DAT_PWR       7
#define RAD_PWR       8
int i=0;
int t_st, t_fn;
/*
  Создаём экземпляр класса RH_ASK приёмника
*/
RH_ASK driver(SPEED, RX_PIN, TX_PIN, PTT_PIN, PTT_INVERTED);

void radio_on() {
  pinMode(RAD_PWR,OUTPUT);
  digitalWrite(RAD_PWR,HIGH);
  if (! driver.init()) {
    Serial.println(F("RF init failed!"));
    while (true) {
      delay(1);
    }
}
}
void setup() {
  Serial.begin(9600);
  Serial.println("Hello");
 
  if (! driver.init()) {
    Serial.println(F("RF init failed!"));
    while (true) {
      delay(1);
    }
  }
  
  pinMode(LED_BUILTIN, OUTPUT);
  pinMode(LED_ST, OUTPUT);
  pinMode(DAT_ST, INPUT);
}

void loop() {
  if (Serial.available()) {
    char data = Serial.read();
    pinMode(DAT_PWR,OUTPUT);
    digitalWrite(DAT_PWR,HIGH);
    if ((data == 'A') and (i == 0) and (digitalRead(DAT_ST) == 0)) {
      i = 1;
      digitalWrite(LED_ST, HIGH);
      Serial.println("Na starte!!!");
    }
  }
  if ((i == 1) and (digitalRead(DAT_ST) == 1)) {
    digitalWrite(DAT_PWR,LOW);
    pinMode(DAT_PWR,INPUT);
    i = 2;
    t_st = millis();
    digitalWrite(LED_ST, LOW);
    Serial.println("Beg!!!");
    radio_on();
  }
  uint8_t data[16];
  uint8_t buflen = sizeof(data);
 // uint8_t i;

  if (driver.recv(data, &buflen)) {
   
    digitalWrite(LED_ST, HIGH);
    if ((i == 2) and (buflen == 4)) {
      t_fn = millis() - t_st;
      Serial.print(t_fn * 0.001);
      Serial.println(" sec.");
      digitalWrite(RAD_PWR,LOW);
      pinMode(RAD_PWR,INPUT);
      i = 0;
    }
    delay(200);
    digitalWrite(LED_ST, LOW);
  }
}
